//----------------------------------------------------------------------------------------------------//

/* 
 *       This Code Was Created By Jan Koci (Kwan) 2002
 *       Visit My Site (GLART) At http://koci.opengl.cz 
 */

//----------------------------------------------------------------------------------------------------//

/* 
 * KFonts.cpp
 * 
 * Zdrojov soubor kter inicializuje, vykresluje, nebo destruuje bitmap fonty
 * 
 *
 */

//----------------------------------------------------------------------------------------------------//

#include "stdafx.h"		// Pouvej hlavikov soubor pedkopilovanch hlavikovch soubor 

//----------------------------------------------------------------------------------------------------//

int	base;			// Display List fontu
extern int fps;		// Globln promnn hodnoty snmk za sekundu
extern HDC hDC;		// Globln promnn Windows Device Contextu - Kontext zazen, kter se pipojuje do grafickho rozhran Windows GDI (Graphics Device Interface)

//----------------------------------------------------------------------------------------------------//

void BuildFont(void)									// Vytvo font
{
	HFONT	font;										// ID - identifiktor Windows Fonu

	base = glGenLists(96);								// Najdi 96 przdnch List

	font = CreateFont(	-14,							// Velikost 
						0,								// ka 
						0,								// hel vykreslen 
						0,								// Orientace hlu 
						FW_BOLD,						// Tun 
						FALSE,							// Italic 
						FALSE,							// Nepodtren
						FALSE,							// Nepekrtl
						ANSI_CHARSET,					// Kdovn
						OUT_TT_PRECIS,					// TrueType 
						CLIP_DEFAULT_PRECIS,			// Zkladn oezvn
						ANTIALIASED_QUALITY,			// Vstupn kvalita
						FF_DONTCARE|DEFAULT_PITCH,		// Styl
						"Courier New");					// Jmno

    SelectObject(hDC, font);							// Vyber objekt
	wglUseFontBitmaps(hDC, 32, 96, base);				// Vytvo bitmaty znakov sady od 32 do 96 a uloz do base
	DeleteObject(font);									// Vyma font
}

//----------------------------------------------------------------------------------------------------//

void DrawFonts(const char *fmt, ...)					// Vykresli text
{
	char text[256];										// String o 256 znacch
	va_list ap;											// Ukazatel na List argument, kter chceme vloit do etzce

	if (fmt == NULL)									// Jestlie fmt neobsahuje dn text
		return;											// Tak nic nedlej a odejdi z funkce

	va_start(ap, fmt);									// Zkus vytvoit kopii fmt v Listu ap
	    vsprintf(text, fmt, ap);						// Konvertuj znaky na aktuln sla znak
	va_end(ap);											// Vymaz ukazatel na List argument

	glPushAttrib(GL_LIST_BIT);							// Zatek Listu Bit
	glListBase(base - 32);								// Nastav znaky od znaku 32 v, jako zkladn Display List
	glCallLists(strlen(text), GL_UNSIGNED_BYTE, text);	// Vykresli Display List
	glPopAttrib();										// Konec Listu Bit
}

//----------------------------------------------------------------------------------------------------//

void DrawFps(void)
{
	CalculateFrameRate();				// Vypotej FPS
	glColor3f(1,1,0);					// Barvu textu nastav na lutou 
	glEnable(GL_BLEND);					// Zapni prhlednost 
	glBlendFunc(GL_ONE, GL_ONE);		// Ve, co je ern je prhledn
	glLoadIdentity();					// Resetuj prostorovou matici
	glTranslatef(-0.35f, 0.25f, -1.0001f);	// Pesu text o 0,1 ped kameru 
	glRasterPos2f(0, 0);		// Pozici textu nastav do levho hornho rohu render okna
	DrawFonts("fps %1i",fps);				// Napi text do render okna
	glDisable(GL_BLEND);				// Vypni prhlednost
	glColor3f(1,1,1);					// Barvu nastav zpt na blou
}

//----------------------------------------------------------------------------------------------------//

void DeleteFont(GLvoid)			// Vyma Font List
{
 	glDeleteLists(base, 96);	// Vyma vechny Listy od base=32 do 96 
}

//----------------------------------------------------------------------------------------------------//

