//----------------------------------------------------------------------------------------------------//

/* 
 *       This Code Was Created By Jan Koci (Kwan) 2002
 *       Visit My Site (GLART) At http://koci.opengl.cz 
 */

//----------------------------------------------------------------------------------------------------//

/*  
 * KMath.cpp
 * 
 * Zdrojov soubor algoritm
 */

//----------------------------------------------------------------------------------------------------//

#include "StdAfx.h"			// Pouvej hlavikov soubor pedkopilovanch hlavikovch soubor

//----------------------------------------------------------------------------------------------------//

//----------------------------------------------------------------------------------------------------//

// Vypotej kolm vektor k vektorm vVector1 a vVector2												
KVector3 Cross(KVector3 vVector1, KVector3 vVector2)	
{
	KVector3 vNormal;	

	// Vypotej kolm vektor (Cross product) 
	vNormal.x = ((vVector1.y * vVector2.z) - (vVector1.z * vVector2.y));
	vNormal.y = ((vVector1.z * vVector2.x) - (vVector1.x * vVector2.z));
	vNormal.z = ((vVector1.x * vVector2.y) - (vVector1.y * vVector2.x));

	// Vra vsledek
	return vNormal;										 
}

//----------------------------------------------------------------------------------------------------//

// Vypotej velikost vektoru
float Magnitude(KVector3 vNormal)
{
	// Podle rovnice:  magnitude = sqrt(V.x^2 + V.y^2 + V.z^2) : 
	// V je vektor, sqrt je druh odmocnina, ^2 znamen na druhou
	return (float)sqrt( (vNormal.x * vNormal.x) + 
						(vNormal.y * vNormal.y) + 
						(vNormal.z * vNormal.z) );
}

//----------------------------------------------------------------------------------------------------//

// Normalizuj vektor, aby jeho velikost nepesahovala hodnotu 1, nebo -1
KVector3 Normalize(KVector3 vVector)
{
	// Vypotej velikost vektoru
	float magnitude = Magnitude(vVector);				

	// Vydl vektor vypotenou hodnotou velikosti vektoru, aby jsme dostali hodnotu mezi 1, -1 
	vVector = vVector / magnitude;		
	
	// Vra vsledek
	return vVector;										
}

//----------------------------------------------------------------------------------------------------//