
//----------------------------------------------------------------------------------------------------//

/* 
 *       This Code Was Created By Jan Koci (Kwan) 2002
 *       Visit My Site (GLART) At http://koci.opengl.cz 
 */

//----------------------------------------------------------------------------------------------------//

/* 
 * KMath.h
 * 
 * Hlavikov soubor algoritm
 * 
 *
 */

//----------------------------------------------------------------------------------------------------//

#ifndef _KMATH_H		// Jestlie nen definovn tento hlavikov soubor
#define _KMATH_H		// Tak ho definuj

//----------------------------------------------------------------------------------------------------//



//----------------------------------------------------------------------------------------------------//
//-------- Definuj tdy
//----------------------------------------------------------------------------------------------------//

class KVector3		// Tda vektor
{
public:
	KVector3() {}	// Konstruktor vektor	
	~KVector3() {}	// Destruktor vektor	
	
	// Konstruktor, kter nm dovoluje kdykoli nastavit vektor 
	KVector3(float X, float Y, float Z)		
	{ 
		x = X; y = Y; z = Z;
	}
	
	// Peten opertor+ aby el cel vektor sest
	KVector3 operator+(KVector3 vVector)		 
	{
		// Vra vsledek soutu vektoru
		return KVector3(vVector.x + x, vVector.y + y, vVector.z + z);
	}

	// Peten opertor- aby el cel vektor odest
	KVector3 operator-(KVector3 vVector)	
	{
		// Vra vsledek rozdlu vektoru
		return KVector3(x - vVector.x, y - vVector.y, z - vVector.z);
	}
	
	// Peten opertor* aby el cel vektor nsobit
	KVector3 operator*(float num)			
	{
		// Vra vsledek souinu vektoru
		return KVector3(x * num, y * num, z * num);
	}

	// Peten opertor/ aby el cel vektor dlit
	KVector3 operator/(float num)			
	{
		// Vra vsledek dlen vektoru
		return KVector3(x / num, y / num, z / num);
	}

	// Hodnota 3D vektoru
	float x, y, z;						
};

//----------------------------------------------------------------------------------------------------//


//----------------------------------------------------------------------------------------------------//
//-------- Definuj funkce
//----------------------------------------------------------------------------------------------------//

// Vypot kolm vektor k vektorm vVector1 a vVector2												
KVector3 Cross(KVector3 vVector1, KVector3 vVector2);

// Vypot velikost vektoru
float Magnitude(KVector3 vNormal);

// Normalizuje vektor, aby jeho velikost nepesahovala hodnotu 1, nebo -1
KVector3 Normalize(KVector3 vVector);

//----------------------------------------------------------------------------------------------------//






//----------------------------------------------------------------------------------------------------//

#endif		// Konec definice tohoto hlavikovho souboru

//----------------------------------------------------------------------------------------------------//