//----------------------------------------------------------------------------------------------------//

/* 
 *       This Code Was Created By Jan Koci (Kwan) 2002
 *       Visit My Site (GLART) At http://koci.opengl.cz 
 */

//----------------------------------------------------------------------------------------------------//

/* 
 * KObjects.cpp
 * 
 * Zdrojov soubor kter nat, vykresluje, destruuje objekty
 * 
 *
 */

//----------------------------------------------------------------------------------------------------//

#include "StdAfx.h"			// Pouvej hlavikov soubor pedkopilovanch hlavikovch soubor

//----------------------------------------------------------------------------------------------------//

extern KTexture Texture1;	// Textura
TPoint3d angle;				// hel rotace objektu
TPoint3d translate;			// Pozice objektu
TPoint3d direction;			// Smr pohybu objektu
bool start=true;			// Pomocn promnn pro natn zkladnch hodnot pi startu aplikace
extern KCamera Camera1;		// Globln promnn kamery

//----------------------------------------------------------------------------------------------------//

char KObject::ReadLine(FILE *f,char *s)				// ti dek ze souboru f a ukldej do etzce s
{
    do												// Cykluj
      {
        fgets(s, 255, f);							// ti znak po znaku maximln vak 255
      } while ((s[0] == '/') || (s[0] == '\n'));    // Dokud se nedostane na konec dky

    return *s;										// Vra funkci hodnotu natenho dku
}

//----------------------------------------------------------------------------------------------------//

int KObject::LoadObject(char *name)					// Nati objekt se souboru (name)
{
    int	ver;											// Pomocn promnn pro poet vrchol objektu
    GLfloat  rx,ry,rz;									// Pomocn promnn pro X, Y, Z pozici vrcholu objektu
    FILE  *filein;										// Definice souboru, ktery budeme st
    char  oneline[255];									// Definice dku souboru s maximln 255 znaky
	int Status=FALSE;									// Kontrolu stavu natan nastav na FALSE

    if (filein = fopen(name, "rt"))						// Zkus otevt soubor pro ten v textovem mdu "rt"
	{
      Status=TRUE;										// Kontrolu stavu natn nastav na TRUE
	  ReadLine(filein,oneline);							// Volej funkci pro naten dky ze souboru
      sscanf(oneline, "Vertices: %d\n", &ver);			// Peti z prvn dky poet vrchol a vsledek pedej promnn ver
      point = new TPoint3d[ver];						// Dynamicky alokuj pam pro poet vrchol objektu
      verts = ver;										// Natenou hodnotu potu vrchol pedej vrcholm objektu

      for (int i=0;i<ver;i++)							// Cykluj podle potu vrchol
        {
          ReadLine(filein,oneline);						// ti dek po dku
    	  sscanf(oneline, "%f %f %f", &rx, &ry, &rz);	// Najdi v dce ti sla typu float a pedej je hodnotm rx, ry, rz
    	  point[i].x = rx;								// Pedej bodu X (aktulniho vrcholu) hodnotu rx
    	  point[i].y = ry;								// Pedej bodu Y (aktulnho vrcholu) hodnotu ry
    	  point[i].z = rz;								// Pedej bodu Z (aktulnho vrcholu) hodnotu rz
        }
      fclose(filein);									// Zavi soubor
    }

	return Status;										// Vra funkci stav natn
}

//----------------------------------------------------------------------------------------------------//

void KObject::DeleteObject(KObject *k)		// Vyma objekt z pamti
{
   	delete [] k->point;						// Vyma vechny body objektu z pamti
}

//----------------------------------------------------------------------------------------------------//

// Vykresli tverec pomoc funkce glBegin(GL_TRIANGLE_FAN)
void KObject::DrawTriangleFan(TPoint2d texcoord0, TPoint3d point0,		// Texturov koordinace a pozice bodu 0
                              TPoint2d texcoord1, TPoint3d point1,		// Texturov koordinace a pozice bodu 1
						      TPoint2d texcoord2, TPoint3d point2,		// Texturov koordinace a pozice bodu 2
						      TPoint2d texcoord3, TPoint3d point3)		// Texturov koordinace a pozice bodu 3
{
	glBegin(GL_TRIANGLE_FAN);										// Zani vykreslovat tverec
	  glTexCoord2f(texcoord0.x, texcoord0.y);  glVertex3f( point0.x, point0.y, point0.z);	// Horn lev bod
      glTexCoord2f(texcoord1.x, texcoord1.y);  glVertex3f( point1.x, point1.y, point1.z);	// Doln lev bod
      glTexCoord2f(texcoord2.x, texcoord2.y);  glVertex3f( point2.x, point2.y, point2.z);	// Doln prav bod
	  glTexCoord2f(texcoord3.x, texcoord3.y);  glVertex3f( point3.x, point3.y, point3.z);	// Horn prav bod
	glEnd();														// Ukoni vykreslovn tverce
}

//----------------------------------------------------------------------------------------------------//

// Inicializuj krychli
void KObject::InitCube(TPoint3d point0,				// Texturov koordinace a pozice bodu 0
					   TPoint3d	point1,				// Texturov koordinace a pozice bodu 1
					   TPoint3d	point2,				// Texturov koordinace a pozice bodu 2
					   TPoint3d	point3,				// Texturov koordinace a pozice bodu 3	
					   TPoint3d	point4,				// Texturov koordinace a pozice bodu 3	
					   TPoint3d	point5,				// Texturov koordinace a pozice bodu 3	
					   TPoint3d	point6,				// Texturov koordinace a pozice bodu 3	
					   TPoint3d	point7,				// Texturov koordinace a pozice bodu 3
						    int TextureListNumber,	// slo Listu textury
							int ObjectListNumber)	// slo Listu krychle													
{
	  TPoint2d texcoord0, texcoord1, texcoord2, texcoord3;  // Promnn texturov koordinace
	  texcoord0.x = 0.0f;									// Texturov koordinace bodu 0
	  texcoord0.y = 1.0f;
	  texcoord1.x = 0.0f;									// Texturov koordinace bodu 1
	  texcoord1.y = 0.0f;
	  texcoord2.x = 1.0f;									// Texturov koordinace bodu 2
	  texcoord2.y = 0.0f;
	  texcoord3.x = 1.0f;									// Texturov koordinace bodu 3
	  texcoord3.y = 1.0f;
	
	  
	  glNewList(ObjectListNumber,GL_COMPILE);											// Vytvo Display List 1
        glBindTexture(GL_TEXTURE_2D, Texture1.TextureList[TextureListNumber]);	// Nastav texturu podle danho Texture Display Listu
	  
	  
	  
	  
	  

	    // eln stna krychle
	    DrawTriangleFan(texcoord0, point0,		// Texturov koordinace a pozice bodu 0
                        texcoord1, point1,		// Texturov koordinace a pozice bodu 1
					    texcoord2, point2,		// Texturov koordinace a pozice bodu 2
					    texcoord3, point3);		// Texturov koordinace a pozice bodu 3

	    // Prav stna krychle
	    DrawTriangleFan(texcoord0, point3,		// Texturov koordinace a pozice bodu 3
                        texcoord1, point2,		// Texturov koordinace a pozice bodu 2
					    texcoord2, point4,		// Texturov koordinace a pozice bodu 4
					    texcoord3, point5);		// Texturov koordinace a pozice bodu 5

	    // Zadn stna krychle
	    DrawTriangleFan(texcoord0, point5,		// Texturov koordinace a pozice bodu 5
                        texcoord1, point4,		// Texturov koordinace a pozice bodu 4
					    texcoord2, point6,		// Texturov koordinace a pozice bodu 6
					    texcoord3, point7);		// Texturov koordinace a pozice bodu 7

	    // Lev stna krychle
	    DrawTriangleFan(texcoord0, point6,		// Texturov koordinace a pozice bodu 6
                        texcoord1, point7,		// Texturov koordinace a pozice bodu 7
					    texcoord2, point0,		// Texturov koordinace a pozice bodu 0
					    texcoord3, point1);		// Texturov koordinace a pozice bodu 1

	    // Horn stna krychle
	    DrawTriangleFan(texcoord0, point7,		// Texturov koordinace a pozice bodu 7
                        texcoord1, point0,		// Texturov koordinace a pozice bodu 0
					    texcoord2, point3,		// Texturov koordinace a pozice bodu 3
					    texcoord3, point5);		// Texturov koordinace a pozice bodu 5

	    // Doln stna krychle
	    DrawTriangleFan(texcoord0, point1,		// Texturov koordinace a pozice bodu 1
                        texcoord1, point2,		// Texturov koordinace a pozice bodu 2
					    texcoord2, point4,		// Texturov koordinace a pozice bodu 4
					    texcoord3, point6);		// Texturov koordinace a pozice bodu 6


	  glEndList();								// Konec Display Listu 1
}

//----------------------------------------------------------------------------------------------------//

int KObject::LoadCube(char *name,				// Cesta k souboru *.txt obsahujc pozice bod krychle
		 int   TextureListNumber,	// slo Listu textury
		 int   CubeListNumber)      // slo Listu krychle
{
	int Status=FALSE;				// Kontrolu stavu natan nastav na FALSE
 
	if (LoadObject(name))			// Pokud pude nast objekt se souboru (name) tak
	{
	  Status=TRUE;					// Kontrolu stavu natn nastav na TRUE
	  InitCube( point[0],			// Texturov koordinace a pozice bodu 0
	  		    point[1],			// Texturov koordinace a pozice bodu 1
			    point[2],			// Texturov koordinace a pozice bodu 2
			    point[3],			// Texturov koordinace a pozice bodu 3	
			    point[4],			// Texturov koordinace a pozice bodu 3	
			    point[5],			// Texturov koordinace a pozice bodu 3	
			    point[6],			// Texturov koordinace a pozice bodu 3	
			    point[7],			// Texturov koordinace a pozice bodu 3
			    TextureListNumber,	// slo Listu textury
			    CubeListNumber);	// slo Listu krychle
	}

	return Status;					// Vra funkci stav natn 
}

//----------------------------------------------------------------------------------------------------//

void KObject::TranRotCube(void)			// Vypotej pohyb a rotaci
{
    // Zatek vpotu pohybu objektu
    if (start)							// Jestlize probh prvn otoka cyklu
    {
      direction.x = 1.0f;				// Nastav smr pohybu objektu v X smru na 1
      direction.y = 1.0f;				// Nastav smr pohybu objektu v Y smru na 1
      direction.z = 1.0f;				// Nastav smr pohybu objektu v Z smru na 1
      translate.z = -8.0f;				// Nastav Z pozici objektu
      start = false;					// Nastav start na false, aby pi dal otoce cyklu se zkladn hodnoty nenataly
    }
    
    if ((translate.x >= 3.0f) || (translate.x <= -3.0f))		// Jetlie X pozice objektu preshne hodnoty 3 nebo -3
    {
        direction.x = -direction.x;								// Oto smr pohybu X
    }
    translate.x = translate.x + (0.01f * direction.x);			// Piti 0.01 pozici X, podle smru pohybu X a velikosti kroku

    if ((translate.y >= 2.0f) || (translate.y <= -2.0f))		// Jetlize Y pozice objektu peshne hodnoty 2 nebo -2
    {
        direction.y = -direction.y;								// Oto smr pohybu Y
    }
    translate.y = translate.y + (0.01f * direction.y);			// Piti 0.01 pozici Y, podle smru pohybu Y a velikosti kroku

    if ((translate.z >= -6.0f) || (translate.z <= -20.0f))		// Jetlize Z pozice objektu peshne hodnoty -6 nebo -20
    {
        direction.z = -direction.z;								// Oto smr pohybu Z
    }
    translate.z = translate.z + (0.01f * direction.z );			// Piti 0.01 pozici Z, podle smru pohybu Z a velikosti kroku
    // Konec vpoctu pohybu objektu

    // Zatek vpotu rotace objektu
    angle.x = angle.x + 0.5f;			// Piti 0.5 hlu X rotace podle velikosti kroku
    if (angle.x >= 360.0f)				// Jestlie je hel vt, ne 360 stup
    {
      angle.x = angle.x -360.0f;		// Odeti 360 stup
    }

    angle.y = angle.y + 1.0f;			// Piti 1 hlu Y rotace podle velikosti kroku
    if (angle.y >= 360.0f)				// Jestlie je hel vt, ne 360 stup
    {
      angle.y = angle.y -360.0f;		// Odeti 360 stup
    }

    angle.z = angle.z + 1.5f;			// Piti 1.5 hlu Z rotace podle velikosti kroku
    if (angle.z >= 360.0f)				// Jestlie je hel vt, ne 360 stup
    {
      angle.z = angle.z -360.0f;		// Odeti 360 stup
    }
    // Konec vpotu rotace objektu
}

//----------------------------------------------------------------------------------------------------//

void KObject::DrawRotateCube(int ObjectListNumber)				// Vykresli rotujc krychli
{
	TranRotCube();												// Vypotej pohyb a rotaci
	
	glPushMatrix();												// Zatek prostorov matice
      // Posouvej a rotuj objektem (ktery je mezi glPushMatrix; a glPopMatrix;) podle vypoctenych hodnot
	  glTranslatef( translate.x, translate.y, translate.z);		// Pohni celm objektem
	  glRotatef( angle.x, 1.0f, 0.0f, 0.0f);					// Rotuj objektem v X smeru
	  glRotatef( angle.y, 0.0f, 1.0f, 0.0f);					// Rotuj objektem v Y smeru
	  glRotatef( angle.z, 0.0f, 0.0f, 1.0f);					// Rotuj objektem v Z smeru
	  
	  glCallList(ObjectListNumber);								// Vykresli List 1
	glPopMatrix();												// Konec prostorov matice
}

//----------------------------------------------------------------------------------------------------//

void KObject::DrawCube(int ObjectListNumber)		// Vykresli statickou krychli
{
	glPushMatrix();									// Zatek prostorov matice
	  glCallList(ObjectListNumber);					// Vykresli List 2
	glPopMatrix();									// Konec prostorov matice
}

//----------------------------------------------------------------------------------------------------//

// Inicializuj Sky Box
void KObject::InitSkyBox(TPoint3d point0,			// Texturov koordinace a pozice bodu 0
					   TPoint3d	point1,				// Texturov koordinace a pozice bodu 1
					   TPoint3d	point2,				// Texturov koordinace a pozice bodu 2
					   TPoint3d	point3,				// Texturov koordinace a pozice bodu 3	
					   TPoint3d	point4,				// Texturov koordinace a pozice bodu 4	
					   TPoint3d	point5,				// Texturov koordinace a pozice bodu 5	
					   TPoint3d	point6,				// Texturov koordinace a pozice bodu 6	
					   TPoint3d	point7,				// Texturov koordinace a pozice bodu 7
					   int      TextureListNumber0,	// slo Listu textury 0
				       int      TextureListNumber1,	// slo Listu textury 1
				       int      TextureListNumber2,	// slo Listu textury 2
				       int      TextureListNumber3,	// slo Listu textury 3
				       int      TextureListNumber4,	// slo Listu textury 4
				       int      TextureListNumber5,	// slo Listu textury 5
		               int      ObjectListNumber)	// slo Listu objektu
													
{
	  // Nastav texturov koordinace, vyma bl okraje tm, e posune koordinaci o 0.005
	  TPoint2d texcoord0, texcoord1, texcoord2, texcoord3;  
	  texcoord0.x = 0.995f;						// Texturov koordinace bodu 0
	  texcoord0.y = 0.995f;
	  texcoord1.x = 0.995f;						// Texturov koordinace bodu 1
	  texcoord1.y = 0.005f;
	  texcoord2.x = 0.005f;						// Texturov koordinace bodu 2
	  texcoord2.y = 0.005f;
	  texcoord3.x = 0.005f;						// Texturov koordinace bodu 3
	  texcoord3.y = 0.995f;

	  


	  glNewList(ObjectListNumber,GL_COMPILE);	// Vytvo Display List podle danho Object Display Listu 
		
	  
	    // eln stna krychle
		glBindTexture(GL_TEXTURE_2D, Texture1.TextureList[TextureListNumber0]);	// Nastav texturu podle danho Texture Display Listu
		DrawTriangleFan(texcoord0, point0,		// Texturov koordinace a pozice bodu 0
                        texcoord1, point1,		// Texturov koordinace a pozice bodu 1
					    texcoord2, point2,		// Texturov koordinace a pozice bodu 2
					    texcoord3, point3);		// Texturov koordinace a pozice bodu 3
	    
		
		// Prav  stna krychle
		glBindTexture(GL_TEXTURE_2D, Texture1.TextureList[TextureListNumber1]);	// Nastav texturu podle danho Texture Display Listu
		DrawTriangleFan(texcoord0, point3,		// Texturov koordinace a pozice bodu 3
                        texcoord1, point2,		// Texturov koordinace a pozice bodu 2
					    texcoord2, point4,		// Texturov koordinace a pozice bodu 4
					    texcoord3, point5);		// Texturov koordinace a pozice bodu 5

		// Zadn stna krychle
		glBindTexture(GL_TEXTURE_2D, Texture1.TextureList[TextureListNumber2]);	// Nastav texturu podle danho Texture Display Listu
		DrawTriangleFan(texcoord0, point5,		// Texturov koordinace a pozice bodu 5
                        texcoord1, point4,		// Texturov koordinace a pozice bodu 4
					    texcoord2, point6,		// Texturov koordinace a pozice bodu 6
					    texcoord3, point7);		// Texturov koordinace a pozice bodu 7
		
		// Lev stna krychle
		glBindTexture(GL_TEXTURE_2D, Texture1.TextureList[TextureListNumber3]);	// Nastav texturu podle danho Texture Display Listu
		DrawTriangleFan(texcoord0, point7,		// Texturov koordinace a pozice bodu 6
                        texcoord1, point6,		// Texturov koordinace a pozice bodu 7
					    texcoord2, point1,		// Texturov koordinace a pozice bodu 0
					    texcoord3, point0);		// Texturov koordinace a pozice bodu 1
		
		// Horn stna krychle
	    glBindTexture(GL_TEXTURE_2D, Texture1.TextureList[TextureListNumber4]);	// Nastav texturu podle danho Texture Display Listu
		DrawTriangleFan(texcoord0, point7,		// Texturov koordinace a pozice bodu 7
                        texcoord1, point0,		// Texturov koordinace a pozice bodu 0
					    texcoord2, point3,		// Texturov koordinace a pozice bodu 3
					    texcoord3, point5);		// Texturov koordinace a pozice bodu 5

		// Doln stna krychle
		glBindTexture(GL_TEXTURE_2D, Texture1.TextureList[TextureListNumber5]);	// Nastav texturu podle danho Texture Display Listu
		DrawTriangleFan(texcoord0, point1,		// Texturov koordinace a pozice bodu 1
                        texcoord1, point6,		// Texturov koordinace a pozice bodu 6
					    texcoord2, point4,		// Texturov koordinace a pozice bodu 4
					    texcoord3, point2);		// Texturov koordinace a pozice bodu 2

	  glEndList();								// Konec Display Listu skyboxu
}

//----------------------------------------------------------------------------------------------------//

int KObject::LoadSkyBox( char *name,					// Cesta k souboru *.txt obsahujc pozice bod krychle
						 int   TextureListNumber0,		// slo Listu textury 0
						 int   TextureListNumber1,		// slo Listu textury 1
						 int   TextureListNumber2,		// slo Listu textury 2
						 int   TextureListNumber3,		// slo Listu textury 3
						 int   TextureListNumber4,		// slo Listu textury 4
						 int   TextureListNumber5,		// slo Listu textury 5
						 int   ObjectListNumber)		// slo Listu objektu
{
	int Status=FALSE;				// Kontrolu stavu natan nastav na FALSE
 
	if (LoadObject(name))			// Pokud pude nast objekt se souboru (name) tak
	{
	  Status=TRUE;					// Kontrolu stavu natn nastav na TRUE
	  InitSkyBox( point[0],			// Texturov koordinace a pozice bodu 0
	  			  point[1],			// Texturov koordinace a pozice bodu 1
			      point[2],			// Texturov koordinace a pozice bodu 2
			      point[3],			// Texturov koordinace a pozice bodu 3	
			      point[4],			// Texturov koordinace a pozice bodu 4	
			      point[5],			// Texturov koordinace a pozice bodu 5	
			      point[6],			// Texturov koordinace a pozice bodu 6	
			      point[7],			// Texturov koordinace a pozice bodu 7
			      TextureListNumber0,	// slo Listu textury 0
				  TextureListNumber1,	// slo Listu textury 1
				  TextureListNumber2,	// slo Listu textury 2
				  TextureListNumber3,	// slo Listu textury 3
				  TextureListNumber4,	// slo Listu textury 4
				  TextureListNumber5,	// slo Listu textury 5
			      ObjectListNumber);	// slo Listu objektu
	}

	return Status;					// Vra funkci stav natn 
}

//----------------------------------------------------------------------------------------------------//

void KObject::DrawSkyBox(int ObjectListNumber)		// Vykresli Sky box
{
	glPushMatrix();									// Zatek prostorov matice
	  glTranslatef(Camera1.Position.x, Camera1.Position.y, Camera1.Position.z);   // Pohybuj skyboxem podle kamery
	  glDisable(GL_DEPTH_TEST);						// Vypni testovn Depth Bufferu, aby byl skybox vdy na pozad
	  glCallList(ObjectListNumber);					// Vykresli List skyboxu
	  glEnable(GL_DEPTH_TEST);						// Zapni testovn Depth Bufferu, aby scna byla vdy ped skyboxem 
	glPopMatrix();									// Konec prostorov matice
}

//----------------------------------------------------------------------------------------------------//

void KObject::DeleteObjectLists(int FirstList, int LastList)	// Vyma objektov Display Listy
{
	glDeleteLists(FirstList, LastList);							// Vyma Display Listy od hodnoty FirstList do hodnoty LastList
}

//----------------------------------------------------------------------------------------------------//

