//----------------------------------------------------------------------------------------------------//

/* 
 *       This Code Was Created By Jan Koci (Kwan) 2002
 *       Visit My Site (GLART) At http://koci.opengl.cz 
 */

//----------------------------------------------------------------------------------------------------//

/* 
 * KObjects.h
 * 
 * Hlavikov soubor zdrojovho souboru KObjects.cpp, kter nat, vykresluje, destruuje objekty
 * 
 *
 */

//----------------------------------------------------------------------------------------------------//

#ifndef _KOBJECTS_H		// Jestlie nen definovn tento hlavikov soubor
#define _KOBJECTS_H		// Tak ho definuj

//----------------------------------------------------------------------------------------------------//


//----------------------------------------------------------------------------------------------------//
//-------- Definuj struktury
//----------------------------------------------------------------------------------------------------//

typedef struct		// Struktura 2D bod
{
	GLfloat	x, y;   // Bod x, y
} TPoint2d;

//----------------------------------------------------------------------------------------------------//

typedef struct			// Struktura 3D bod
{
	GLfloat	x, y, z;    // Bod x, y, z
} TPoint3d;

//----------------------------------------------------------------------------------------------------//




//----------------------------------------------------------------------------------------------------//
//-------- Definuj tdy 
//----------------------------------------------------------------------------------------------------//

class KObject			// Tda objekt
{
public:					// Veejn promnn a funkce
	KObject() {}		// Konstruktor objekt
	~KObject() {}		// Destruktor objekt
	////////////////////////////////////////
	////////////// Promnn ////////////////
	////////////////////////////////////////
    int  verts;			// Poet vrchol
    TPoint3d  *point;	// Vrchol je sloen z bodu x, y, z



    ////////////////////////////////////////
	////////////// Funkce //////////////////
	////////////////////////////////////////
	// Naten krychli
	int LoadCube( char *name,					// Cesta k souboru *.txt obsahujc pozice bod krychle
				  int   TextureListNumber,		// slo Listu textury
		          int   ObjectListNumber);		// slo Listu krychle

	void DrawRotateCube(int ObjectListNumber);	// Vykreslovn rotujc krychle
	void DrawCube(int ObjectListNumber);		// Vykreslovn statick krychle
    

    


	// Naten Sky Boxu
	int LoadSkyBox( char *name,					// Cesta k souboru *.txt obsahujc pozice bod krychle
				  int   TextureListNumber0,		// slo Listu textury 0
				  int   TextureListNumber1,		// slo Listu textury 1
				  int   TextureListNumber2,		// slo Listu textury 2
				  int   TextureListNumber3,		// slo Listu textury 3
				  int   TextureListNumber4,		// slo Listu textury 4
				  int   TextureListNumber5,		// slo Listu textury 5
		          int   ObjectListNumber);		// slo Listu krychle

	void DrawSkyBox(int ObjectListNumber);					// Vykreslovn SkyBoxu
	
	
	void DeleteObject(KObject *k);							// Vymazn objektu
	void DeleteObjectLists(int FirstList, int LastList);	// Vymae objektov Display Listy



private:	// Soukrom promnn a funkce
	////////////////////////////////////////
	////////////// Funkce //////////////////
	////////////////////////////////////////
     
	// Vykresli tverec pomoc funkce glBegin(GL_TRIANGLE_FAN)
	void DrawTriangleFan(TPoint2d texcoord0, TPoint3d point0,		// Texturov koordinace a pozice bodu 0
                         TPoint2d texcoord1, TPoint3d point1,		// Texturov koordinace a pozice bodu 1
						 TPoint2d texcoord2, TPoint3d point2,		// Texturov koordinace a pozice bodu 2
						 TPoint2d texcoord3, TPoint3d point3);		// Texturov koordinace a pozice bodu 3
	
	char ReadLine(FILE *f,char *s);				// te dek ze souboru f a ukld do etzce s
	int  LoadObject(char *name);				// Nate objekt se souboru (name)


	// Inicializace krychle
	void InitCube(TPoint3d point0,				// Texturov koordinace a pozice bodu 0
				  TPoint3d point1,				// Texturov koordinace a pozice bodu 1
				  TPoint3d point2,				// Texturov koordinace a pozice bodu 2
				  TPoint3d point3,				// Texturov koordinace a pozice bodu 3	
				  TPoint3d point4,				// Texturov koordinace a pozice bodu 4	
				  TPoint3d point5,				// Texturov koordinace a pozice bodu 5	
				  TPoint3d point6,				// Texturov koordinace a pozice bodu 6	
				  TPoint3d point7,				// Texturov koordinace a pozice bodu 7
				  int      TextureListNumber,	// slo Listu textury
				  int      ObjectListNumber);	// slo Listu objektu


	void TranRotCube(void);						// Vypot pohyb a rotaci krychle

	// Inicializace Sky Boxu
	void InitSkyBox(TPoint3d point0,				// Texturov koordinace a pozice bodu 0
				    TPoint3d point1,				// Texturov koordinace a pozice bodu 1
				    TPoint3d point2,				// Texturov koordinace a pozice bodu 2
				    TPoint3d point3,				// Texturov koordinace a pozice bodu 3	
				    TPoint3d point4,				// Texturov koordinace a pozice bodu 4	
				    TPoint3d point5,				// Texturov koordinace a pozice bodu 5	
				    TPoint3d point6,				// Texturov koordinace a pozice bodu 6	
				    TPoint3d point7,				// Texturov koordinace a pozice bodu 7
				    int      TextureListNumber0,	// slo Listu textury 0
				    int      TextureListNumber1,	// slo Listu textury 1
				    int      TextureListNumber2,	// slo Listu textury 2
				    int      TextureListNumber3,	// slo Listu textury 3
				    int      TextureListNumber4,	// slo Listu textury 4
				    int      TextureListNumber5,	// slo Listu textury 5
		            int      ObjectListNumber);		// slo Listu objektu

};

//----------------------------------------------------------------------------------------------------//








//----------------------------------------------------------------------------------------------------//

#endif					// Konec definice tohoto hlavikovho souboru

//----------------------------------------------------------------------------------------------------//