//----------------------------------------------------------------------------------------------------//

/* 
 *       This Code Was Created By Jan Koci (Kwan) 2002
 *       Visit My Site (GLART) At http://koci.opengl.cz 
 */

//----------------------------------------------------------------------------------------------------//

/*  
 * KScene.cpp
 * 
 * Zdrojov soubor kter spout vechny dleit funkce scny
 */

//----------------------------------------------------------------------------------------------------//

#include "StdAfx.h"			// Pouvej hlavikov soubor pedkopilovanch hlavikovch soubor

//----------------------------------------------------------------------------------------------------//

KTexture Texture1;				// Textura1
extern KCamera Camera1;			// Globln promnn kamery
KObject Cube1, Cube2, SkyBox1;	// Objekt krychle1 a krychle2

//----------------------------------------------------------------------------------------------------//

void InitScene(void)			// Nati scnu
{
	// Zkus nast texturu, slo Listu 0, Prvn krychle
	if (!Texture1.LoadGLTextures("Textures/picture01.bmp", 0))	
	{
		MessageBox(NULL,"Load file 'Textures/picture01.bmp' is not exist","Loading error",MB_OK | MB_ICONINFORMATION);    // vyho hlku
	}
	
	// Zkus nast texturu, slo Listu 1, Druh krychle
	if (!Texture1.LoadGLTextures("Textures/picture02.bmp", 1))	
	{
		MessageBox(NULL,"Load file 'Textures/picture02.bmp' is not exist","Loading error",MB_OK | MB_ICONINFORMATION);    // vyho hlku
	}

    // Zkus nast texturu, slo Listu 2, Front skybox
	if (!Texture1.LoadGLTextures("Textures/SkyBox/front.bmp", 2))	
	{
		MessageBox(NULL,"Load file 'Textures/SkyBox/front.bmp' is not exist","Loading error",MB_OK | MB_ICONINFORMATION);    // vyho hlku
	}

	// Zkus nast texturu, slo Listu 3, Right skybox
	if (!Texture1.LoadGLTextures("Textures/SkyBox/right.bmp", 3))	
	{
		MessageBox(NULL,"Load file 'Textures/SkyBox/right.bmp.bmp' is not exist","Loading error",MB_OK | MB_ICONINFORMATION);    // vyho hlku
	}

	// Zkus nast texturu, slo Listu 4, Back skybox
	if (!Texture1.LoadGLTextures("Textures/SkyBox/back.bmp", 4))	
	{
		MessageBox(NULL,"Load file 'Textures/SkyBox/back.bmp' is not exist","Loading error",MB_OK | MB_ICONINFORMATION);    // vyho hlku
	}

	// Zkus nast texturu, slo Listu 5, Left skybox
	if (!Texture1.LoadGLTextures("Textures/SkyBox/left.bmp", 5))	
	{
		MessageBox(NULL,"Load file 'Textures/SkyBox/left.bmp' is not exist","Loading error",MB_OK | MB_ICONINFORMATION);    // vyho hlku
	}

	// Zkus nast texturu, slo Listu 6, Top skybox
	if (!Texture1.LoadGLTextures("Textures/SkyBox/top.bmp", 6))	
	{
		MessageBox(NULL,"Load file 'Textures/SkyBox/top.bmp' is not exist","Loading error",MB_OK | MB_ICONINFORMATION);    // vyho hlku
	}

	// Zkus nast texturu, slo Listu 7, Bottom skybox
	if (!Texture1.LoadGLTextures("Textures/SkyBox/bottom.bmp", 7))	
	{
		MessageBox(NULL,"Load file 'Textures/SkyBox/bottom.bmp' is not exist","Loading error",MB_OK | MB_ICONINFORMATION);    // vyho hlku
	}





	// Zkus nast krychli 1
	if (!Cube1.LoadCube("Objects/cube.txt",		// Cesta k souboru *.txt obsahujc pozice bod krychle
					0,							// slo Listu textury
					1))							// slo Listu krychle
	{
		MessageBox(NULL,"Load file 'Objects/cube.txt' is not exist","Loading error",MB_OK | MB_ICONINFORMATION);    // vyho hlku
	}

	// Zkus nast krychli 2
	if (!Cube2.LoadCube("Objects/cube2.txt",	// Cesta k souboru *.txt obsahujc pozice bod krychle
					1,							// slo Listu textury
					2))							// slo Listu krychle
    {
		MessageBox(NULL,"Load file 'Objects/cube2.txt' is not exist","Loading error",MB_OK | MB_ICONINFORMATION);    // vyho hlku
	}

	// Zkus nast Sky Box
	if (!SkyBox1.LoadSkyBox("Objects/skybox.txt",	// Cesta k souboru *.txt obsahujc pozice bod krychle
					2,								// slo Listu textury 0
					3,								// slo Listu textury 1
					4,								// slo Listu textury 2
					5,								// slo Listu textury 3
					6,								// slo Listu textury 4
					7,								// slo Listu textury 5
					3))								// slo Listu krychle
    {
		MessageBox(NULL,"Load file 'Objects/skybox.txt' is not exist","Loading error",MB_OK | MB_ICONINFORMATION);    // vyho hlku
	}
	
	BuildFont();								// Vytvo bitmap fonty
}

//----------------------------------------------------------------------------------------------------//

void DrawScene(void)				// Vykresli scnu
{
	  Camera1.Look();				// Pohybuj a rotuj kamerou			
	  SkyBox1.DrawSkyBox(3);		// Vykresli Sky Box (3 = ObjectList3)
	  Cube1.DrawRotateCube(1);		// Vykresli rotujc krychli (1 = ObjectList1)
	  Cube2.DrawCube(2);			// Vykresli statickou krychli (2 = ObjectList2)
	  DrawFps();					// Vykresli FPS	
}

//----------------------------------------------------------------------------------------------------//

void DeleteScene(void)				// Vyma scnu		
{
	Cube1.DeleteObject(&Cube1);		// Vyma krychli1
	Cube2.DeleteObject(&Cube2);		// Vyma krychli2
	Cube1.DeleteObjectLists(1, 3);	// Vyma Objekt List 1 a 3
	DeleteFont();					// Vyma fonty
}

//----------------------------------------------------------------------------------------------------//
