//----------------------------------------------------------------------------------------------------//

/* 
 *       This Code Was Created By Jan Koci (Kwan) 2002
 *       Visit My Site (GLART) At http://koci.opengl.cz 
 */

//----------------------------------------------------------------------------------------------------//

/* 
 * KTextures.cpp
 * 
 * Zdrojov soubor kter pracuje s texturama
 * 
 *
 */

//----------------------------------------------------------------------------------------------------//

#include "StdAfx.h"			// Pouvej hlavikov soubor pedkopilovanch hlavikovch soubor

//----------------------------------------------------------------------------------------------------//

AUX_RGBImageRec *LoadBMP(char *Filename)				// Nati obrzek *.bmp
{
	FILE *File=NULL;									// Handle souboru

	if (!Filename)										// Zkus jestli existuje jmno souboru
	{
		return NULL;									// Jinak ukoni funkci
	}

	File=fopen(Filename,"r");							// Otevi soubor pro ten

	if (File)											// Jestlie soubor existuje
	{
		fclose(File);									// Uzavi soubor
		return auxDIBImageLoad(Filename);				// Nati bitmapu z otevenho souboru
	}

	return NULL;										// Jestlie se ntn souboru nezda, tak vra NULL
}

//----------------------------------------------------------------------------------------------------// 

int KTexture::LoadGLTextures(char *Filename, int ListNumber)	// Nati obrzek *.bmp, peve ho na texturu a pia textue slo Listu 
{
	int Status=FALSE;											// Kontrolu stavu natan nastav na FALSE
	
	

	AUX_RGBImageRec *TextureImage[1];							// Alokuj pam pro obraz textury

	memset(TextureImage,0,sizeof(void *)*1);					// Nastav ukazatel na NULL

	// Jestlie pude nast obrzek
	if (TextureImage[0]=LoadBMP(Filename))
	{
		Status=TRUE;											// Kontrolu stavu natn nastav na TRUE

		glGenTextures(1, &TextureList[ListNumber]);				// Vytvo texturov List 

		// Zatek generovn textury
		glBindTexture(GL_TEXTURE_2D, TextureList[ListNumber]);	// Nastav texturov List s nsledujcmi parametry
		
		// Parametry 2D textury
		glTexImage2D(GL_TEXTURE_2D, 0, 3, TextureImage[0]->sizeX, TextureImage[0]->sizeY, 0, GL_RGB, GL_UNSIGNED_BYTE, TextureImage[0]->data);
		
		// Linern rozlo (rozthni) texturu do celho objektu, pokud je textura men nez plocha objektu
		glTexParameterf(GL_TEXTURE_2D,GL_TEXTURE_MIN_FILTER,GL_LINEAR );		
		
		// Linern rozlo (zmeni) texturu, pokud je textura vt ne plocha objektu
		glTexParameterf(GL_TEXTURE_2D,GL_TEXTURE_MAG_FILTER,GL_LINEAR );
		// Konec generovn textury
	}

	if (TextureImage[0])							// Jestlie existuje obraz textury 0
	{
		if (TextureImage[0]->data)					// Jestlie obraz textury obsahuje njak data
		{
			free(TextureImage[0]->data);			// Tak data vyma z pamti
		}

		free(TextureImage[0]);						// Vyma celou strukturu obrazu textury 
	}

	return Status;									// Vra funkci stav natn 
}

//----------------------------------------------------------------------------------------------------//

