//----------------------------------------------------------------------------------------------------//

/* 
 *       This Code Was Created By Jan Koci (Kwan) 2002
 *       Visit My Site (GLART) At http://koci.opengl.cz 
 */

//----------------------------------------------------------------------------------------------------//

/*  
 * main.cpp
 * 
 * Hlavikov soubor zkladnho nastaven OpenGL aplikace
 */


//----------------------------------------------------------------------------------------------------//

#include "StdAfx.h"			// Pouvej hlavikov soubor pedkopilovanch hlavikovch soubor

//----------------------------------------------------------------------------------------------------//

// Promnn
HDC			hDC=NULL;		// Windows Device Context - Kontext zazen, kter se pipojuje do grafickho rozhran Windows GDI (Graphics Device Interface)
HGLRC		hRC=NULL;		// Rendering Context - pipojuje OpenGL do HDC (Windows Device Context)
HWND		hWnd=NULL;		// Handle render okna
HINSTANCE	hInstance;		// Instance programu

bool	keys[256];			// Pole pro kontrolu stisknutch klves
bool	active=TRUE;		// Promnn kter uruje, zda je okno minimalizovan, i ne, pokud ano, aplikace se ukon
bool	fullscreen=TRUE;	// Promnn kter uruje, zda m bt okno ve fullscreenu, i ne

LRESULT	CALLBACK WndProc(HWND, UINT, WPARAM, LPARAM);	// Zprvy render okna 

KCamera Camera1;			// Kamera



//----------------------------------------------------------------------------------------------------//

// Zmna velikosti OpenGL scny, pi zmn velikosti render okna
GLvoid ReSizeGLScene(GLsizei width, GLsizei height)		// Funkce se provd pi startu aplikace, nebo pi zmn velikosti render okna
{
	if (height==0)									    // Predchzej dlen nulou
	{
		height=1;										// Nastav ku okna na 1
	}

	glViewport(0,0,width,height);						// Nastav velikost render plochy

	glMatrixMode(GL_PROJECTION);						// Nastav matici zobrazen prostoru
	glLoadIdentity();									// Resetuj tuto matici

	// Vypoti velikost render plochy. Nastav hel pohledu kamery, nejbli a nejvzdlenj viditeln bod
	gluPerspective(30.0f,(GLfloat)width/(GLfloat)height, 0.1f, 500);

	glMatrixMode(GL_MODELVIEW);							// Nastav matici zobrazen objektu
	glLoadIdentity();									// Resetuj tuto matici
}

//----------------------------------------------------------------------------------------------------//

// Zkladni nastaven OpenGL pi startu aplikace
int InitGL(GLvoid)										
{
	glShadeModel(GL_SMOOTH);							// Zapni hladk stnovn
	glClearColor(0.0f, 0.0f, 0.0f, 0.5f);				// Nastav ern pozad render scny
	
	// Nastav Depth Buffer
	// Objekty, kter jsou bl kamery pekresluji objekty, kter jsou vzdlenj od kamery
	// Pokud by se nepouval Depth Buffer objekty by se kreslili v tom poad, jak jsou renderovny
	glClearDepth(1.0f);									// Vyma Depth Buffer
	glEnable(GL_DEPTH_TEST);							// Zapni testovn Depth Bufferu

	// Vypotej nejlep korekci perspektivy. Vkon se maliko sn, avak ve se vykresl v lep kvalit
	glHint(GL_PERSPECTIVE_CORRECTION_HINT, GL_NICEST);	// Vypotej nejlep korekci perspektivy
	glEnable(GL_TEXTURE_2D);							// Zapni 2D texturovn

	InitScene();										// Inicializuj scnu

	return TRUE;										// Vra TRUE pokud ve probhlo OK
}

//----------------------------------------------------------------------------------------------------//

// Vykresli scnu
void DrawGLScene(GLvoid)									
{
	glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);	// Vyma render scnu a Depth Buffer
	glLoadIdentity();									// Resetuj modelovou matici
	DrawScene();										// Vykresli scnu
}

//----------------------------------------------------------------------------------------------------//

// Ukoni OpenGL instance a zavi okno
GLvoid KillGLWindow(GLvoid)								// Funkce se provd pi zavrn aplikace
{
	if (fullscreen)										// Jestlie pouvm FullScreen md
	{
		ChangeDisplaySettings(NULL,0);					// Pepni obrazovku do pvodnho rozlien
		ShowCursor(TRUE);								// Vykresli kurzor myi
	}

	if (hRC)											// Jestlie pouvm Rendering Context
	{
		if (!wglMakeCurrent(NULL,NULL))					// Zkus uvolnit Windows Device Context a Rendering Context. Pokud to nepude tak
		{
			MessageBox(NULL,"Release Of DC And RC Failed.","SHUTDOWN ERROR",MB_OK | MB_ICONINFORMATION);    // vyho hlku
		}

		if (!wglDeleteContext(hRC))						// Zkus vymazat Rendering Context. Pokud to nepude tak 
		{
			MessageBox(NULL,"Release Rendering Context Failed.","SHUTDOWN ERROR",MB_OK | MB_ICONINFORMATION);    // vyho hlku
		}
		hRC=NULL;										// Nastav Rendering Context na NULL
	}

	if (hDC && !ReleaseDC(hWnd,hDC))					// Jestlie pouvm Windows Device Context, zkus ho uvolnit. Pokud to nepude tak  
	{
		MessageBox(NULL,"Release Device Context Failed.","SHUTDOWN ERROR",MB_OK | MB_ICONINFORMATION);    // vyho hlku
		hDC=NULL;										// Nastav Windows Device Context na NULL
	}

	if (hWnd && !DestroyWindow(hWnd))					// Jestlie pouvm handle render okna, zkus ho vymazat. Pokud to nepude tak 
	{
		MessageBox(NULL,"Could Not Release hWnd.","SHUTDOWN ERROR",MB_OK | MB_ICONINFORMATION);    // vyho hlku
		hWnd=NULL;										// Nastav handle render okna na NULL
	}

	if (!UnregisterClass("OpenGL",hInstance))			// Zkus odregistrovat tdu render okna. Pokud to nepude tak 
	{
		MessageBox(NULL,"Could Not Unregister Class.","SHUTDOWN ERROR",MB_OK | MB_ICONINFORMATION);    // vyho hlku
		hInstance=NULL;									// Nastav hInstance na NULL
	}

	DeleteScene();										// Vyma scnu
}

//----------------------------------------------------------------------------------------------------//

/*	Vytvo OpenGL render okno.  Parametry jsou:					            *
 *	title			- Titulek okna                          				*
 *	width			- ka okna                            				*
 *	height			- Vka okna											*
 *	bits			- Poet bit, barevn hloubka (8/16/24/32)				*
 *	fullscreenflag	- FullScreen mode (TRUE), md okna (FALSE)				*/
BOOL CreateGLWindow(char* title, int width, int height, int bits, bool fullscreenflag)
{
	GLuint		PixelFormat;			// Zeptej se Windows na pixel formt a ulo ho 
	WNDCLASS	wc;						// Tda okna. Struktura uchovv informace o okn
	DWORD		dwExStyle;				// Rozen styl okna
	DWORD		dwStyle;				// Styl okna
	LPCTSTR     MyIcon="KEngine.ico";
	
	// Nastav velikost okna
	RECT		WindowRect;				// Vytvo obdlnk podle hodnot levho hornho a pravho dolnho rohu
	WindowRect.left=(long)0;			// Nastav levou hodnotu na 0
	WindowRect.right=(long)width;		// Nastav pravou hodnotu podle hodnoty width
	WindowRect.top=(long)0;				// Nastav horn hodnotu na 0
	WindowRect.bottom=(long)height;		// Nastav doln hodnotu podle hodnoty height

	fullscreen=fullscreenflag;			// Pedej hodnotu fullscreenu (TRUE, nebo FALSE)

	// Vytvo instanci okna a definuj tdu okna 
	hInstance			= GetModuleHandle(NULL);				// Vytvo instanci okna
	wc.style			= CS_HREDRAW | CS_VREDRAW | CS_OWNDC;	// Nastav styl okna, aby se mohlo pohybovat okraji okna a zrove vytvo Device Context
	wc.lpfnWndProc		= (WNDPROC) WndProc;					// Sleduj zprvy programu
	wc.cbClsExtra		= 0;									// dn extra data nechci
	wc.cbWndExtra		= 0;									// dn extra data nechci
	wc.hInstance		= hInstance;							// Nastav Instance
	wc.hIcon			= LoadIcon(hInstance,MAKEINTRESOURCE(IDI_ICONKENGINE));    //Nati ikonu KEngine.ico ze souboru zdroju KResource
	wc.hCursor			= LoadCursor(NULL, IDC_ARROW);			// Nati standartn kurzor myi
	wc.hbrBackground	= NULL;									// Barvu pozad nenastavuj, to nastav OpenGL
	wc.lpszMenuName		= NULL;									// Menu nechci
	wc.lpszClassName	= "OpenGL";								// Jmno tdy nastav na OpenGL

	// Registruj tridu okna
	if (!RegisterClass(&wc))									// Zkus registrovat tdu okna. Pokud to nepude tak 
	{
		MessageBox(NULL,"Failed To Register The Window Class.","ERROR",MB_OK|MB_ICONEXCLAMATION);    // vyho hlku
		return FALSE;											// a ukoni funkci
	}
	
	// FullScreen?
	if (fullscreen)												// Jestlie jsem nastavil fullscreen md
	{
		DEVMODE dmScreenSettings;								// Device Mode
		memset(&dmScreenSettings,0,sizeof(dmScreenSettings));	// Vytvo istou pamt
		dmScreenSettings.dmSize=sizeof(dmScreenSettings);		// Nastav velikost Devmode struktury
		dmScreenSettings.dmPelsWidth	= width;				// Nastav ku
		dmScreenSettings.dmPelsHeight	= height;				// Nastav vku
		dmScreenSettings.dmBitsPerPel	= bits;					// Nastav poet bit na pixel
		dmScreenSettings.dmFields=DM_BITSPERPEL|DM_PELSWIDTH|DM_PELSHEIGHT;    // Uri, jestli pjdou nastavit tyto hodnoty  

		// Zkus nastavit md a vra vsledek. CDS_FULLSCREEN odstran start litu
		if (ChangeDisplaySettings(&dmScreenSettings,CDS_FULLSCREEN)!=DISP_CHANGE_SUCCESSFUL)
		{
			// Jestlie nepude nastavit FullScreen md, tak vyho hlku o monosti pepnut do okennho mdu
			if (MessageBox(NULL,"The Requested Fullscreen Mode Is Not Supported By\nYour Video Card. Use Windowed Mode Instead?","KEngine",MB_YESNO|MB_ICONEXCLAMATION)==IDYES)
			{
				fullscreen=FALSE;		// Pepni do okennho mdu. FullScreen nastav na FALSE
			}
			else
			{
				// Pokud ignoruju hlku, tak vyho dal chybovou hlku a ukoni aplikaci
				MessageBox(NULL,"Program Will Now Close.","ERROR",MB_OK|MB_ICONSTOP);
				return FALSE;									// Ukoni funkci
			}
		}
	}

	if (fullscreen)												// Znovu se zeptej, jestli je stle aktivn FullScreen md. Pokud ano tak
	{
		dwExStyle=WS_EX_APPWINDOW;								// Nastav okno, aby se vykreslovalo ped vechny ostatn okna
		dwStyle=WS_POPUP;										// Nastav okno bez okraj
		ShowCursor(FALSE);										// Schovej kurzor myi
	}
	else														// Jinak nastav okenn md
	{
		dwExStyle=WS_EX_APPWINDOW | WS_EX_WINDOWEDGE;			// Nastav 3D vzhled okna
		dwStyle=WS_OVERLAPPEDWINDOW;							// Nastav okraje okna, titulek a min/max ikony
	}

	AdjustWindowRectEx(&WindowRect, dwStyle, FALSE, dwExStyle);		// Nastav okno v poadovan velikosti s poadovanmi parametry, ve fullscreen mdu tento pkaz nem dn vliv

	
	// Zkus vykreslit okno. 
	if (!(hWnd=CreateWindowEx(	dwExStyle,							// Rozen styl okna
								"OpenGL",							// Jmno tdy
								title,								// Titulek okna
								dwStyle |							// Vybran styl
								WS_CLIPSIBLINGS |					// Poadovan styl
								WS_CLIPCHILDREN,					// Poadovan styl
								0, 0,								// Pozice okna. Lev horni roh obrazovky
								WindowRect.right-WindowRect.left,	// Vypotej ku okna
								WindowRect.bottom-WindowRect.top,	// Vypotej vku okna
								NULL,								// Nechci rodiovsk okno
								NULL,								// Nechci menu
								hInstance,							// Instance okna
								NULL)))								// Nevytvej jin okno pomoci WM_CREATE
	{
		// Pokud se nepoda vytvorit okno, tak
		KillGLWindow();								// Ukoni vechny OpenGL instance
		MessageBox(NULL,"Window Creation Error.","ERROR",MB_OK|MB_ICONEXCLAMATION);    // Vyho hlku, e nejde okno vytvoit
		return FALSE;								// Ukoni funkci
	}

	
	// Nastav formt pixelu
	static	PIXELFORMATDESCRIPTOR pfd=				// konstanta pfd ekne Windows jak pixel formt poaduji
	{
		sizeof(PIXELFORMATDESCRIPTOR),				// Velikost Pixel Format Descriptoru
		1,											// slo verze
		PFD_DRAW_TO_WINDOW |						// Formt mus podporovat Window
		PFD_SUPPORT_OPENGL |						// Formt mus podporovat OpenGL
		PFD_DOUBLEBUFFER,							// Formt mus podporovat Double Buffering
		PFD_TYPE_RGBA,								// Poaduji zobrazen barev ve formtu RGBA
		bits,										// Poauji hloubku barev podle hodnoty bits
		0, 0, 0, 0, 0, 0,							// Barevn bity ignoruj
		0,											// Nechci Alpha Buffer
		0,											// Bit posunuti nechci
		0,											// Accumulation buffer nechci
		0, 0, 0, 0,									// Accumulation bity nechci
		DEPTH_BITS,									// Poaduji 16Bit Z-Buffer (Depth Buffer)  
		0,											// Nechci Stencil Buffer
		0,											// Nechci Auxiliary Buffer
		PFD_MAIN_PLANE,								// Hlavn vykreslovac vrstva
		0,											// Rezervovno
		0, 0, 0										// Nechci vrstvu masek
	};
	
	if (!(hDC=GetDC(hWnd)))							// Zkus pedat device context. Jinak
	{
		KillGLWindow();								// Ukoni OpenGL instance
		MessageBox(NULL,"Can't Create A GL Device Context.","ERROR",MB_OK|MB_ICONEXCLAMATION);    // Vyho chybovou hlku
		return FALSE;								// Ukoni funkci
	}

	if (!(PixelFormat=ChoosePixelFormat(hDC,&pfd)))	// Zkus najit zadan pixelov formt. Jinak
	{
		KillGLWindow();								// Ukoni OpenGL instance
		MessageBox(NULL,"Can't Find A Suitable PixelFormat.","ERROR",MB_OK|MB_ICONEXCLAMATION);    // Vyho chybovou hlku
		return FALSE;								// Ukonci funkci
	}

	if(!SetPixelFormat(hDC,PixelFormat,&pfd))		// Zkus nastavit pixelov formt a hodit ho do kontextu zazen. Pokud se to nepoda
	{
		KillGLWindow();								// Ukoni OpenGL instance
		MessageBox(NULL,"Can't Set The PixelFormat.","ERROR",MB_OK|MB_ICONEXCLAMATION);    // Vyho chybovou hlku
		return FALSE;								// Ukonci funkci
	}

	if (!(hRC=wglCreateContext(hDC)))				// Zkus pedat kontext zazen do rendering kontextu Windows. Jinak
	{
		KillGLWindow();								// Ukoni OpenGL instance
		MessageBox(NULL,"Can't Create A GL Rendering Context.","ERROR",MB_OK|MB_ICONEXCLAMATION);    // Vyho chybovou hlku
		return FALSE;								// Ukonci funkci
	}

	if(!wglMakeCurrent(hDC,hRC))					// Zkus pipojit OpenGL Rendering Context do Windows Device Context, kter komunikuje s Windows GDI (Graphics Device Interface). Jinak
	{
		KillGLWindow();								// Ukoni OpenGL instance
		MessageBox(NULL,"Can't Activate The GL Rendering Context.","ERROR",MB_OK|MB_ICONEXCLAMATION);   // Vyho chybovou hlku
		return FALSE;								// Ukonci funkci
	}

	ShowWindow(hWnd,SW_SHOW);						// Zobraz render okno
	SetForegroundWindow(hWnd);						// Nastav nejvy prioritu okna
	SetFocus(hWnd);									// Nastav fokus klvesnice pro render okno
	ReSizeGLScene(width, height);					// Nastav ku a vku OpenGL scny 

	if (!InitGL())									// Zkus provst zkladn nastaven OpenGL. Jinak 
	{
		KillGLWindow();								// Ukoni OpenGL instance
		MessageBox(NULL,"Initialization Failed.","ERROR",MB_OK|MB_ICONEXCLAMATION);    // Vyho chybovou hlku
		return FALSE;								// Ukoni funkci
	}

	return TRUE;									// Hotovo,  ve je OK
}

//----------------------------------------------------------------------------------------------------//

// Odchytvej zprvy render okna
LRESULT CALLBACK WndProc(	HWND	hWnd,			// Handle render okna
							UINT	uMsg,			// Zprvy render okna
							WPARAM	wParam,			// Dodaten informan zprvy okna
							LPARAM	lParam)			// Dodaten informan zprvy okna
{
	switch (uMsg)									// Testuj zprvy Windows
	{
		case WM_ACTIVATE:							// Hldej zprvu Window o aktivaci
		{
			if (!HIWORD(wParam))					// Zkus, jestli nen okno minimalizovan. Pokud nen minimalizovan
			{
				active=TRUE;						// Tak nastav program jako aktivn 
			}
			else									// Pokud je okno minimalizovan
			{
				active=FALSE;						// Tak nastav program jako neaktivn 
			}

			return 0;								// Vra se a hldej dl
		}

		case WM_SYSCOMMAND:							// Hldej, jestli systm ned o sputn spoie obrazovky, nebo uspornho reimu
		{
			switch (wParam)							// Jestlie se tak stane
			{
				case SC_SCREENSAVE:					// Spoi chce startovat ?
				case SC_MONITORPOWER:				// Usporn reim chce startovat ?
				return 0;							// Ho jim nulu a neotravujou
			}
			break;									// Vra se a hldej dl 
		}

		case WM_CLOSE:								// Hldej, jestli nen poadavek na ukonen aplikace. Jestli se tak stane
		{
			PostQuitMessage(0);						// Poli ukonovac zprvu
			return 0;								// Vra se 
		}

		case WM_KEYDOWN:							// Hldej, jestli makm klvesu. Jestlie makm klvesu tak
		{
			keys[wParam] = TRUE;					// Poli kladnou zprvu TRUE a jej parametr. Nap klvesa s kdem 40 je keys[40] = TRUE;
			return 0;								// Vra se a hldej dl 
		}

		case WM_KEYUP:								// Hldej, jestli uvoluju klvesu. Jestlie uvoluju klvesu
		{
			keys[wParam] = FALSE;					// Poli zpornou zprvu FALSE a jej parametr. Nap klvesa s kodem 40 je keys[40] = FALSE;
			return 0;								// Vra se a hldej dl 
		}	

		case WM_SIZE:								// Hldej, jestli nemnm velikost okna. Pokud ji mnm
		{
			ReSizeGLScene(LOWORD(lParam),HIWORD(lParam));  // Volej funkci pro zmnu OpenGL scny. LoWord=Width, HiWord=Height
			return 0;								// Vra se a hldej dl 
		}
	}

	// Dal zprvy m nezajmaj, tak pedej funkci DefWindowProc, a si s nima Windows poradi sm
	return DefWindowProc(hWnd,uMsg,wParam,lParam);
}

//----------------------------------------------------------------------------------------------------//

// Hlavn vstupn funkce aplikace. Zavolej vytvec rutiny, obsluhuj zprvy a pohldej interakci s mmi poadavky.
int APIENTRY WinMain(HINSTANCE hInstance,       // Instance aplikace
                     HINSTANCE hPrevInstance,   // Pedchoz instance
                     LPSTR     lpCmdLine,		// Parametry pkazovho dku
                     int       nCmdShow)		// Sestaven okna
{
 	MSG		msg;								// Struktura Windows zprv
	BOOL	done=FALSE;							// Promnna pro ukoneni smyky. Pokud je done=FALSE aplikace be, pokud se zmn na done=TRUE aplikace se ukon 

	// Zeptej se m, jestli chci pouvat FullScreen md, nebo okenn md 
	if (MessageBox(NULL,"Would You Like To Run In Fullscreen Mode?", "Start FullScreen?",MB_YESNO|MB_ICONQUESTION)==IDNO)
	{
		fullscreen=FALSE;							// Okenn md
	}

	// Zkus volat funkci pro vytvoeni OpenGL render okna, s nsledujcimi parametry. Pokud se to nepoda tak
	if (!CreateGLWindow("Sky Box 2",SCREEN_WIDTH,SCREEN_HEIGHT,COLOR_BITS,fullscreen))
	{
		return 0;									// Ukoni aplikaci
	}

	// Hlavni smyka aplikace
	while(!done)									// Smyka funguje pokud je done=FALSE
	{
		if (PeekMessage(&msg,NULL,0,0,PM_REMOVE))	// Testuj, jestli nepila njak zprva ?
		{
			if (msg.message==WM_QUIT)				// Jestlie pila zprva o ukonen aplikace tak
			{
				done=TRUE;							// Ukoni aplikaci  done=TRUE
			}
			else									// Jinak
			{
				TranslateMessage(&msg);				// Pelo zprvu
				DispatchMessage(&msg);				// Odeli zprvu a dej ji k dispozici funkci WndProc(), nebo at se s n zabv Windows
			}
		}
		else										// Kdy nejsou dn zprvy
		{
			// Vykresli OpenGL Scnu
			if (active)								// Je aplikace aktivn ?
			{
				if (keys[VK_ESCAPE])				// Klepnul jsem na ESC ?
				{
					done=TRUE;						// Tak ukoni aplikaci
				}
				else								// Jestlie jsem neklepnul na klvesu ESC
				{
					DrawGLScene();					// Volej funkci pro kreslen scny
					SwapBuffers(hDC);				// Prohod buffery (Double Buffering)
													// Pouitm double bufferu kreslme ve na skrytou obrazovku.
					                                // Kdy prehazujeme buffer, viditelna obrazovka se stane skrytou 
					                                // a skryt se zobraz. Touto cestou nevidme na scnu blikat.
					
				}
			}

			

			if (keys[VK_F1])						// Jestlie jsem klepnul na klvesu F1?
			{
				keys[VK_F1]=FALSE;					// Tak vrat klavese F1 opt hodnotu FALSE
				KillGLWindow();						// Ukoni OpenGL instance a zavi okno
				fullscreen=!fullscreen;				// Pepnej mezi FullScreen a Okennim mdem
				// Vytvo nov OpenGL render okno
				if (!CreateGLWindow("NeHe's OpenGL Framework",SCREEN_WIDTH,SCREEN_HEIGHT,COLOR_BITS,fullscreen))
				{
					return 0;						// Ukoni aplikaci, pokud se okno nepovedlo vytvoit
				}
			}
			
			if ((keys[VK_UP]) || (keys['W']))		// Jestlie jsem klepnul na klvesu ipka nahoru, nebo na klvesu W
			{
				Camera1.GoForward();				// Pepotej pozici kamery, aby se posunula dopedu
			}
			
			if ((keys[VK_DOWN]) || (keys['S']))		// Jestlie jsem klepnul na klvesu ipka dolu, nebo na klvesu S
			{								
				Camera1.GoBackward();				// Pepotej pozici kamery, aby se posunula dozadu
			}

			if ((keys[VK_PRIOR]) || (keys['E']))	// Jestlie jsem klepnul na klvesu Page Up, nebo na klvesu E
			{
				Camera1.GoUp();						// Pepotej pozici kamery, aby se posouvala nahoru
				
			}

			if ((keys[VK_NEXT]) || (keys['C']))		// Jestlie jsem klepnul na klvesu Page Down, nebo na klvesu C
			{
				Camera1.GoDown();					// Pepotej pozici kamery, aby se posouvala dolu
			}

			if (keys['A'])							// Jestlie jsem klepnul na klvesu A
			{
				Camera1.StrafeLeft();				// Pepotej pozici kamery, aby se posouvala doleva
			}

			if (keys['D'])							// Jestlie jsem klepnul na klvesu D
			{
				Camera1.StrafeRight();				// Pepotej pozici kamery, aby se posouvala doprava	
			}

			if (keys[VK_LEFT])						// Jestlie jsem klepnul na klvesu ipka doleva
			{				
				Camera1.TurnLeft();					// Pepotej rotaci kamery, aby rotovala doleva
			}

			if (keys[VK_RIGHT])						// Jestlie jsem klepnul na klvesu ipka doprava
			{
				Camera1.TurnRight();				// Pepotej rotaci kamery, aby rotovala doprava
			}

			if (keys[VK_HOME])						// Jestlie jsem klepnul na klvesu Home
			{
				Camera1.TurnUp();					// Pepotej rotaci kamery, aby rotovala nahoru
			}

			if (keys[VK_END])						// Jestlie jsem klepnul na klvesu End
			{
				Camera1.TurnDown();					// Pepotej rotaci kamery, aby rotovala dolu
			}

			if (keys['Q'])							// Jestlie jsem klepnul na klvesu Q
			{
				//	Camera1.InclineLeft();				// Pepotej rotaci kamery, aby se naklonila doleva
			}

			if (keys['E'])							// Jestlie jsem klepnul na klvesu E
			{
			//	Camera1.InclineRight();				// Pepotej rotaci kamery, aby se naklonila doprava
			}



		}
	}
    
	// Ukonovn aplikace
	KillGLWindow();									// Ukoni OpenGL instance a zavi okno
	return (msg.wParam);							// Definitivn ukoni aplikaci
}

//----------------------------------------------------------------------------------------------------//





